<!DOCTYPE html>
<html lang="en">
    <head>
        <meta charset="UTF-8">
        <title>Chat in real time</title>
        <script src="https://cdn.tailwindcss.com"></script>
        <script>
            tailwind.config = {
                theme: {
                    extend: {
                        colors: {
                            clifford: '#da373d',
                        }
                    }
                }
            }
        </script>
        <script type="module">
            import {io} from 'https://cdn.socket.io/4.3.2/socket.io.esm.min.js'
            const socket = io({
                auth: {
                    serverOffset:0
                }
            })
            /*
            form-message
            input-message
             */

            const form = document.getElementById('form-message')
            const input = document.getElementById('input-message')
            const messageContent = document.getElementById('messages-content')
            const messages = document.getElementById('messages')
            form.addEventListener('submit', (e) => {
                e.preventDefault()
                if(input.value){
                    socket.emit('chat message', input.value)
                    input.value = ''
                }

            })
            socket.on('chat message', (msg, serverOffset) => {
                const item = `<li class="relative max-w-lg mr-auto bg-slate-700 py-5 px-2 rounded-xl">
                        <span class="absolute top-0 left-0 flex h-3 w-3">
                          <span class="animate-ping absolute inline-flex h-full w-full rounded-full bg-sky-400 opacity-75"></span>
                          <span class="relative inline-flex rounded-full h-3 w-3 bg-sky-500"></span>
                        </span>
                            ${msg}
                    </li>`
                messages.insertAdjacentHTML('beforeend', item)
                // esta linea nos ayudara para ver donde se quedo el chat, de esta manera evitamos que los mensajes se mesclen
                socket.auth.serverOffset = serverOffset
                messageContent.scrollTop = messageContent.scrollHeight
            })
        </script>
        <style>
            :root {
                color-scheme: light dark;
            }
            ::selection {
                background-color: #da373d;
                color: #fff;
            }
            @layer utilities {
                .content-auto {
                    content-visibility: auto;
                }
            }
            input[type="text"] {
                -webkit-appearance: none;
                -moz-appearance: none;
                appearance: none;
            }
            input[type="text"]:focus {
                outline: none;
                border-top: none;
                border-bottom: 3px solid rgba(21, 128, 61, 0.99);
                border-left: none;
                border-right: none;
            }
        </style>
        <script src="https://cdn.tailwindcss.com?plugins=forms,typography,aspect-ratio,line-clamp"></script>
    </head>
    <body>
    <main class="flex divide-x divide-slate-500">
        <aside class="w-[20%] h-[100vh] resize-x relative overflow-y-auto">
            <div class="sticky top-0 bg-slate-700 py-2">
                <div class="flex p-2 justify-between items-center">
                    <h1 class="flex-1 text-2xl">Chats</h1>
                    <div>
                        <button class="hover:bg-gray-700 p-2 rounded-2xl" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path d="M5.433 13.917l1.262-3.155A4 4 0 017.58 9.42l6.92-6.918a2.121 2.121 0 013 3l-6.92 6.918c-.383.383-.84.685-1.343.886l-3.154 1.262a.5.5 0 01-.65-.65z" />
                                <path d="M3.5 5.75c0-.69.56-1.25 1.25-1.25H10A.75.75 0 0010 3H4.75A2.75 2.75 0 002 5.75v9.5A2.75 2.75 0 004.75 18h9.5A2.75 2.75 0 0017 15.25V10a.75.75 0 00-1.5 0v5.25c0 .69-.56 1.25-1.25 1.25h-9.5c-.69 0-1.25-.56-1.25-1.25v-9.5z" />
                            </svg>
                        </button>
                        <button class="hover:bg-gray-700 p-2 rounded-2xl" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path fill-rule="evenodd" d="M2.628 1.601C5.028 1.206 7.49 1 10 1s4.973.206 7.372.601a.75.75 0 01.628.74v2.288a2.25 2.25 0 01-.659 1.59l-4.682 4.683a2.25 2.25 0 00-.659 1.59v3.037c0 .684-.31 1.33-.844 1.757l-1.937 1.55A.75.75 0 018 18.25v-5.757a2.25 2.25 0 00-.659-1.591L2.659 6.22A2.25 2.25 0 012 4.629V2.34a.75.75 0 01.628-.74z" clip-rule="evenodd" />
                            </svg>
                        </button>
                    </div>
                </div>
                <form class="w-full px-2">
                    <input class="w-full outline-none bg-slate-900 rounded-lg" type="text" placeholder="Buscar un chat" />
                </form>
            </div>
            <ul role="list" class="flex-1 flex flex-col py-6 px-2 gap-2">
                <li class="flex justify-between p-2 rounded-xl hover:bg-slate-700">
                    <div class="flex">
                        <img class="h-10 w-10 rounded-full" src="https://res.cloudinary.com/dhq9acwqr/image/upload/v1691598451/nft/Default_Maximaliset_Rococo_Astral_Escape_Splash_art_portrait_o_1_e2e0b95e-0ee5-4cc0-a9ad-d6c6728c59da_1_qpf9sr.jpg" alt="" />
                        <div class="ml-3 overflow-hidden">
                            <p class="text-sm font-medium text-sky-600">{person.name}</p>
                            <p class="text-sm text-slate-500 truncate">{person.final-message}</p>
                        </div>
                    </div>
                    <div class="flex flex-col justify-center items-center">
                        <p class="text-sm text-slate-500 truncate">
                            08:54
                        </p>
                        <button class="" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path fill-rule="evenodd" d="M8.5 3.528v4.644c0 .729-.29 1.428-.805 1.944l-1.217 1.216a8.75 8.75 0 013.55.621l.502.201a7.25 7.25 0 004.178.365l-2.403-2.403a2.75 2.75 0 01-.805-1.944V3.528a40.205 40.205 0 00-3 0zm4.5.084l.19.015a.75.75 0 10.12-1.495 41.364 41.364 0 00-6.62 0 .75.75 0 00.12 1.495L7 3.612v4.56c0 .331-.132.649-.366.883L2.6 13.09c-1.496 1.496-.817 4.15 1.403 4.475C5.961 17.852 7.963 18 10 18s4.039-.148 5.997-.436c2.22-.325 2.9-2.979 1.403-4.475l-4.034-4.034A1.25 1.25 0 0113 8.172v-4.56z" clip-rule="evenodd" />
                            </svg>
                        </button>
                    </div>
                </li>
                <li class="flex justify-between p-2 rounded-xl hover:bg-slate-700">
                    <div class="flex">
                        <img class="h-10 w-10 rounded-full" src="https://res.cloudinary.com/dhq9acwqr/image/upload/v1691598451/nft/Default_Maximaliset_Rococo_Astral_Escape_Splash_art_portrait_o_1_e2e0b95e-0ee5-4cc0-a9ad-d6c6728c59da_1_qpf9sr.jpg" alt="" />
                        <div class="ml-3 overflow-hidden">
                            <p class="text-sm font-medium text-sky-600">{person.name}</p>
                            <p class="text-sm text-slate-500 truncate">{person.final-message}</p>
                        </div>
                    </div>
                    <div class="flex flex-col justify-center items-center">
                        <p class="text-sm text-slate-500 truncate">
                            08:54
                        </p>
                        <button class="" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path fill-rule="evenodd" d="M8.5 3.528v4.644c0 .729-.29 1.428-.805 1.944l-1.217 1.216a8.75 8.75 0 013.55.621l.502.201a7.25 7.25 0 004.178.365l-2.403-2.403a2.75 2.75 0 01-.805-1.944V3.528a40.205 40.205 0 00-3 0zm4.5.084l.19.015a.75.75 0 10.12-1.495 41.364 41.364 0 00-6.62 0 .75.75 0 00.12 1.495L7 3.612v4.56c0 .331-.132.649-.366.883L2.6 13.09c-1.496 1.496-.817 4.15 1.403 4.475C5.961 17.852 7.963 18 10 18s4.039-.148 5.997-.436c2.22-.325 2.9-2.979 1.403-4.475l-4.034-4.034A1.25 1.25 0 0113 8.172v-4.56z" clip-rule="evenodd" />
                            </svg>
                        </button>
                    </div>
                </li>
            </ul>
        </aside>
        <article class="flex-1 flex flex-col bg-slate-700 h-[100vh] divide-y divide-slate-500">
            <header class="h-auto flex gap-2">
                <div class="flex-1 rounded-r-2xl bg-slate-100 dark:bg-slate-800">
                    <figure class="py-2 px-1">
                        <img class="w-10 h-10  rounded-full" src="https://res.cloudinary.com/dhq9acwqr/image/upload/v1691598451/nft/Default_Maximaliset_Rococo_Astral_Escape_Splash_art_portrait_o_1_e2e0b95e-0ee5-4cc0-a9ad-d6c6728c59da_1_qpf9sr.jpg" alt="">
                    </figure>
                </div>
                <div class="flex gap-x-2">
                    <div class="flex bg-gray-900 justify-center px-1 items-center rounded-2xl">
                        <button class="hover:bg-gray-700 p-2 rounded-2xl" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path d="M3.25 4A2.25 2.25 0 001 6.25v7.5A2.25 2.25 0 003.25 16h7.5A2.25 2.25 0 0013 13.75v-7.5A2.25 2.25 0 0010.75 4h-7.5zM19 4.75a.75.75 0 00-1.28-.53l-3 3a.75.75 0 00-.22.53v4.5c0 .199.079.39.22.53l3 3a.75.75 0 001.28-.53V4.75z" />
                            </svg>


                        </button>
                        <button class="hover:bg-gray-700 p-2 rounded-2xl" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path fill-rule="evenodd" d="M2 3.5A1.5 1.5 0 013.5 2h1.148a1.5 1.5 0 011.465 1.175l.716 3.223a1.5 1.5 0 01-1.052 1.767l-.933.267c-.41.117-.643.555-.48.95a11.542 11.542 0 006.254 6.254c.395.163.833-.07.95-.48l.267-.933a1.5 1.5 0 011.767-1.052l3.223.716A1.5 1.5 0 0118 15.352V16.5a1.5 1.5 0 01-1.5 1.5H15c-1.149 0-2.263-.15-3.326-.43A13.022 13.022 0 012.43 8.326 13.019 13.019 0 012 5V3.5z" clip-rule="evenodd" />
                            </svg>

                        </button>
                    </div>

                    <div class="flex justify-center items-center gap-2">
                        <button class="hover:bg-gray-900 p-2 rounded-2xl" type="button">
                            <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                <path fill-rule="evenodd" d="M9 3.5a5.5 5.5 0 100 11 5.5 5.5 0 000-11zM2 9a7 7 0 1112.452 4.391l3.328 3.329a.75.75 0 11-1.06 1.06l-3.329-3.328A7 7 0 012 9z" clip-rule="evenodd" />
                            </svg>

                        </button>
                    </div>
                </div>
            </header>
            <main id="messages-content" class="flex-1 bg-slate-900 overflow-y-auto scroll-smooth" >
                <ul id="messages" class="flex flex-col p-5 gap-2.5">

                </ul>
            </main>
            <footer class="h-auto py-5 px-2 flex gap-5 bg-slate-100 dark:bg-slate-800">
                <div class="flex justify-center items-center gap-2">
                    <button class="hover:bg-gray-900 p-2 rounded-2xl" type="button">
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 24 24" fill="currentColor" class="fill-blue-500 w-5 h-5">
                            <path fill-rule="evenodd" d="M12 2.25c-5.385 0-9.75 4.365-9.75 9.75s4.365 9.75 9.75 9.75 9.75-4.365 9.75-9.75S17.385 2.25 12 2.25zm-2.625 6c-.54 0-.828.419-.936.634a1.96 1.96 0 00-.189.866c0 .298.059.605.189.866.108.215.395.634.936.634.54 0 .828-.419.936-.634.13-.26.189-.568.189-.866 0-.298-.059-.605-.189-.866-.108-.215-.395-.634-.936-.634zm4.314.634c.108-.215.395-.634.936-.634.54 0 .828.419.936.634.13.26.189.568.189.866 0 .298-.059.605-.189.866-.108.215-.395.634-.936.634-.54 0-.828-.419-.936-.634a1.96 1.96 0 01-.189-.866c0-.298.059-.605.189-.866zm2.023 6.828a.75.75 0 10-1.06-1.06 3.75 3.75 0 01-5.304 0 .75.75 0 00-1.06 1.06 5.25 5.25 0 007.424 0z" clip-rule="evenodd" />
                        </svg>
                    </button>
                    <button class="hover:bg-gray-900 p-2 rounded-2xl" type="button">
                        <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                            <path d="M12.232 4.232a2.5 2.5 0 013.536 3.536l-1.225 1.224a.75.75 0 001.061 1.06l1.224-1.224a4 4 0 00-5.656-5.656l-3 3a4 4 0 00.225 5.865.75.75 0 00.977-1.138 2.5 2.5 0 01-.142-3.667l3-3z" />
                            <path d="M11.603 7.963a.75.75 0 00-.977 1.138 2.5 2.5 0 01.142 3.667l-3 3a2.5 2.5 0 01-3.536-3.536l1.225-1.224a.75.75 0 00-1.061-1.06l-1.224 1.224a4 4 0 105.656 5.656l3-3a4 4 0 00-.225-5.865z" />
                        </svg>
                    </button>
                </div>
                <div class="flex-1">
                    <form id="form-message" class="w-full flex justify-between items-center">
                        <input id="input-message" class="w-full outline-0 bg-slate-900 py-2 px-2 rounded-lg active:bg-slate-600 active:text-emerald-600" type="text" placeholder="write yor message" />
                        <div class="flex justify-center items-center gap-2">
                            <button class="hover:bg-gray-900 p-2 rounded-2xl" type="submit">
                                <svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 20 20" fill="currentColor" class="fill-blue-500 w-5 h-5">
                                    <path d="M3.105 2.289a.75.75 0 00-.826.95l1.414 4.925A1.5 1.5 0 005.135 9.25h6.115a.75.75 0 010 1.5H5.135a1.5 1.5 0 00-1.442 1.086l-1.414 4.926a.75.75 0 00.826.95 28.896 28.896 0 0015.293-7.154.75.75 0 000-1.115A28.897 28.897 0 003.105 2.289z" />
                                </svg>
                            </button>
                        </div>
                    </form>
                </div>

            </footer>
        </article>
    </main>
    </body>
</html>